Index: src/main/java/com/tourMate/services/TransportManager.java
===================================================================
--- src/main/java/com/tourMate/services/TransportManager.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/services/TransportManager.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -13,5 +13,5 @@
 public interface TransportManager {
 
-    public void createTransport(String transportName, String carBrand, String carType, int carManufacturedYear, int noPassengers, int noBags, long EMBG, User owner, String carPlate);
+    public void createTransport(String transportName, String carBrand, String carType, int carManufacturedYear, int noPassengers, int noBags, long EMBG, Long userId, String carPlate);
 
     public void deleteTransport(long transportId);
@@ -30,4 +30,6 @@
     public TransportReservation findTransportReservationByID(long reservationID);
 
+    List<TransportReservation> findTransportReservationByTransportId(long reservationID);
+
     public List<TransportReservation> getTransportReservations();
 
@@ -35,11 +37,7 @@
     public Transport getTransportById(long transportId);
 
-<<<<<<< HEAD
     List<Reviews> getReviewsForTransport(long transportId);
 
     public List<TransportListingDto> getTransportsAvailableByFilters (String from, String to, Date date, int numPassengers);
-=======
-    public List<TransportListingDto> getTransportsAvailableByFilters (String from, String to, Date date);
->>>>>>> parent of ac19a0c (authContext impl, admin panel impl, search bar fixes, reservations listings impl)
 
     public List<TransportReservation> getTransportsReservationsByUserID(long userID);
@@ -48,7 +46,4 @@
 
     public void createTransportAvailable(Transport transport, String departureLocation, String arrivalLocation, Date date, Integer noSeats, Date departureHour, Collection<TransportRoute> routes);
-
-    public void editTransportReservation(Transport transport, long reservationID, String departureLocation, String arrivalLocation, Date date, Integer noSeats, User user, Date departureHour);
-
     public void editTransportAvailable(Transport transport, long availableID, String departureLocation, String arrivalLocation, Date date, Integer noSeats, Date departureHour);
 
@@ -67,4 +62,6 @@
 
     List<TransportReservationUserDto> findPastTransportReservationsByUser(Long userId);
+
+    void setReservationReviewed(Long reservationId);
 }
 
Index: src/main/java/com/tourMate/services/UsersManager.java
===================================================================
--- src/main/java/com/tourMate/services/UsersManager.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/services/UsersManager.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -16,3 +16,7 @@
 
     public void editUser(long userID, String name, String surname, String email, Date birthDate, String address, String contact);
+    public List<User> getUnapprovedUsers();
+    public void approveUserProfile(long userId);
+
+    void unlock(Long id);
 }
Index: src/main/java/com/tourMate/services/impl/BusinessManagerImpl.java
===================================================================
--- src/main/java/com/tourMate/services/impl/BusinessManagerImpl.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/services/impl/BusinessManagerImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -2,7 +2,10 @@
 
 import com.tourMate.dao.BusinessDao;
+import com.tourMate.dao.UsersDao;
 import com.tourMate.entities.Business;
+import com.tourMate.entities.Role;
 import com.tourMate.entities.User;
 import com.tourMate.services.BusinessManager;
+import com.tourMate.services.UsersManager;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.stereotype.Service;
@@ -16,29 +19,54 @@
     @Autowired
     BusinessDao businessDao;
+    @Autowired
+    UsersDao usersDao;
+    @Autowired
+    UsersManager usersManager;
 
     @Override
     public void createBusiness(Business business, long userId) {
-        businessDao.createBusiness(business, userId);
+        User u = usersManager.findUserByID(userId);
+        business.setUser(u);
+        businessDao.createBusiness(business);
     }
 
     @Override
     public List<Business> getUnapprovedBusinessesOfUser(long userId) {
-        return businessDao.getUnapprovedBusinessesOfUser(userId);
+        User u = usersManager.findUserByID(userId);
+        return businessDao.getUnapprovedBusinessesOfUser(u);
     }
 
     @Override
     public void deleteBusiness(long businessId) {
-        businessDao.deleteBusiness(businessId);
+        Business business = businessDao.findBusinessById(businessId);
+        businessDao.deleteBusiness(business);
 
     }
 
     @Override
-    public boolean hasBusiness(long userId){
-        return businessDao.hasBusiness(userId);
+    public List<Business> getUnapprovedBusinesses() {
+        return businessDao.getUnapprovedBusinesses();
     }
 
     @Override
-    public List<Business> getCreatedBusinesses() {
-        return businessDao.getCreatedBusinesses();
+    public void approveBusiness(Long businessId) {
+        Business b = findBusinessById(businessId);
+        b.setApproved(true);
+        businessDao.approveBusiness(b);
+        changeUserRoleBusiness(b.getUser().getUserID());
+    }
+
+    private void changeUserRoleBusiness(Long userId)
+    {
+        User u = usersDao.findUserByID(userId);
+        Role r = usersDao.findById(3L);
+        u.setRole(r);
+        usersDao.updateUser(u);
+    }
+
+    @Override
+    public boolean hasBusiness(long userId){
+        User u = usersManager.findUserByID(userId);
+        return businessDao.hasBusiness(u);
     }
 
@@ -50,5 +78,12 @@
     @Override
     public void editBusiness(long businessId, String name, String phone, String address, String edbs, User user, boolean approved) {
-        businessDao.editBusiness(businessId, name, phone, address, edbs, user, approved);
+        Business business = findBusinessById(businessId);
+        business.setName(name);
+        business.setPhone(phone);
+        business.setAddress(address);
+        business.setEdbs(edbs);
+        business.setUser(user);
+        business.setApproved(approved);
+        businessDao.editBusiness(business);
     }
 
Index: src/main/java/com/tourMate/services/impl/HotelManagerImpl.java
===================================================================
--- src/main/java/com/tourMate/services/impl/HotelManagerImpl.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/services/impl/HotelManagerImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -4,12 +4,13 @@
 import com.tourMate.dao.UsersDao;
 import com.tourMate.dto.HotelDto;
+import com.tourMate.dto.HotelReservationDto;
+import com.tourMate.dto.HotelReservationUserDto;
 import com.tourMate.entities.*;
 import com.tourMate.services.HotelManager;
+import com.tourMate.services.UsersManager;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.stereotype.Service;
-import org.springframework.web.multipart.MultipartFile;
 
 import java.time.Duration;
-import java.util.Collection;
 import java.util.Date;
 import java.util.List;
@@ -24,5 +25,6 @@
     @Autowired
     UsersDao usersDao;
-
+    @Autowired
+    UsersManager usersManager;
 
     @Override
@@ -33,5 +35,7 @@
     @Override
     public void createHotel(Hotels hotels, long userId) {
-        hotelDao.createHotel(hotels, userId);
+        User u = usersManager.findUserByID(userId);
+        hotels.setOwner(u);
+        hotelDao.createHotel(hotels);
     }
 
@@ -39,5 +43,4 @@
     @Override
     public List<Hotels> getHotels() {
-        List<Hotels> hoteli = hotelDao.getHotels();
         return hotelDao.getHotels();
     }
@@ -45,5 +48,6 @@
     @Override
     public List<Hotels> getHotelsForUser(long userId) {
-        return hotelDao.getHotelsForUser(userId);
+        User u = usersManager.findUserByID(userId);
+        return hotelDao.getHotelsForUser(u);
     }
 
@@ -55,10 +59,19 @@
     @Override
     public void editHotel(long hotelId, String hotelName, String hotelDescripiton, String hotelLocation, String hotelEDBS, Boolean parking, Boolean petFriendly, Boolean internetAvailable) {
-        hotelDao.editHotel(hotelId, hotelName, hotelDescripiton, hotelLocation, hotelEDBS, parking, petFriendly, internetAvailable);
+        Hotels hotel = hotelDao.findHotelByID(hotelId);
+        hotel.setHotelName(hotelName);
+        hotel.setHotelDescripiton(hotelDescripiton);
+        hotel.setHotelLocation(hotelLocation);
+        hotel.setHotelEDBS(hotelEDBS);
+        hotel.setParking(parking);
+        hotel.setPetFriendly(petFriendly);
+        hotel.setInternetAvailable(internetAvailable);
+        hotelDao.editHotel(hotel);
     }
 
     @Override
     public void deleteHotel(long hotelId) {
-        hotelDao.deleteHotel(hotelId);
+        Hotels h = findHotelByID(hotelId);
+        hotelDao.deleteHotel(h);
     }
 
@@ -76,5 +89,6 @@
     @Override
     public List<HotelRoom> getRoomsOfHotel(long hotelId) {
-        return hotelDao.getRoomsOfHotel(hotelId);
+        Hotels h = findHotelByID(hotelId);
+        return hotelDao.getRoomsOfHotel(h);
     }
 
@@ -99,5 +113,6 @@
     @Override
     public void deleteHotelImage(long hotelImageId){
-        hotelDao.deleteHotelImage(hotelImageId);
+        HotelsImages hotelsImages = findHotelImageById(hotelImageId);
+        hotelDao.deleteHotelImage(hotelsImages);
     }
 
@@ -108,20 +123,31 @@
 
     @Override
-    public void createRoom(Hotels hotel, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price) {
-        hotelDao.createRoom(hotel, hotelRoomDescription, hotelRoomName, kitchenAvailable, airConditioning, balcony, price);
+    public void createRoom(Hotels hotel, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price, int numOfBeds) {
+        HotelRoom hotelRoom = new HotelRoom(hotel, hotelRoomDescription, hotelRoomName, kitchenAvailable, airConditioning, balcony, price, numOfBeds);
+        hotelDao.createRoom(hotelRoom);
     }
 
     @Override
     public void editRoom(long hotelRoomId, Hotels hotel, String hotelRoomDescription, String hotelRoomName, Boolean kitchenAvailable, Boolean airConditioning, Boolean balcony, double price) {
-        hotelDao.editRoom(hotelRoomId, hotel, hotelRoomDescription, hotelRoomName, kitchenAvailable, airConditioning, balcony, price);
+        HotelRoom hr = findRoomById(hotelRoomId);
+        hr.setHotel(hotel);
+        hr.setHotelRoomDescription(hotelRoomDescription);
+        hr.setHotelRoomName(hotelRoomName);
+        hr.setKitchenAvailable(kitchenAvailable);
+        hr.setAirConditioning(airConditioning);
+        hr.setBalcony(balcony);
+        hr.setPrice(price);
+        hotelDao.editRoom(hr);
     }
 
     @Override
     public void deleteRoom(long hotelRoomId) {
-        hotelDao.deleteRoom(hotelRoomId);
-    }
-
-    @Override
-    public List<HotelRoomAvailable> getRoomsAvailable(Long id) {
+        HotelRoom hr = findRoomById(hotelRoomId);
+        hotelDao.deleteRoom(hr);
+    }
+
+
+    @Override
+    public List<HotelRoomAvailable> getRoomsAvailableById(Long id) {
         return hotelDao.getRoomsAvailable(id);
     }
@@ -129,10 +155,16 @@
     @Override
     public void createRoomAvailible(HotelRoom hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds) {
-        hotelDao.createRoomAvailible(hotelRoom, dateFrom, dateTo, numberOfBeds);
+        HotelRoomAvailable hra = new HotelRoomAvailable(hotelRoom, dateFrom, dateTo, numberOfBeds);
+        hotelDao.createRoomAvailible(hra);
     }
 
     @Override
     public void editRoomAvailible(long hotelRoomAvailableId, HotelRoom hotelRoom, Date dateFrom, Date dateTo, int numberOfBeds) {
-        hotelDao.editRoomAvailible(hotelRoomAvailableId, hotelRoom, dateFrom, dateTo, numberOfBeds);
+        HotelRoomAvailable hr = findAvailibleRoomById(hotelRoomAvailableId);
+        hr.setHotelRoom(hotelRoom);
+        hr.setDateFrom(dateFrom);
+        hr.setDateTo(dateTo);
+        hr.setNumberOfBeds(numberOfBeds);
+        hotelDao.editRoomAvailible(hr);
     }
 
@@ -142,11 +174,14 @@
         roomAvailable.setNumberOfBeds(numberOfBeds-1);
         HotelRoom room = hotelDao.findRoomById(hotelRoomId);
-        hotelDao.createRoomAvailible(room, roomAvailable.getDateFrom(), from, 1);
-        hotelDao.createRoomAvailible(room, to, roomAvailable.getDateTo(), 1);
+        HotelRoomAvailable hra = new HotelRoomAvailable(room,roomAvailable.getDateFrom(),from,1);
+        hotelDao.createRoomAvailible(hra);
+        HotelRoomAvailable hra1 = new HotelRoomAvailable(room,to,roomAvailable.getDateTo(),1);
+        hotelDao.createRoomAvailible(hra1);
     }
 
     @Override
     public void deleteRoomAvailible(long hotelRoomAvailableId) {
-        hotelDao.deleteRoomAvailible(hotelRoomAvailableId);
+        HotelRoomAvailable hra = findAvailibleRoomById(hotelRoomAvailableId);
+        hotelDao.deleteRoomAvailible(hra);
     }
 
@@ -167,7 +202,7 @@
 
     @Override
-    public List<HotelDto> getRoomsAvailibilityByDateAndLocation(String hotelLocation, Date dateFrom, Date dateTo, int numberOfBeds) {
+    public List<HotelDto> getRoomsAvailibilityByDateAndLocation(String hotelLocation, Date dateFrom, Date dateTo, int numberOfBeds, Boolean flexible) {
         long numberOfNights = Duration.between(dateFrom.toInstant(), dateTo.toInstant()).toDays();
-        List<HotelRoomAvailable> roomsAvailible = hotelDao.getRoomsAvailibilityByDateAndLocation(hotelLocation, dateFrom, dateTo, numberOfBeds);
+        List<HotelRoomAvailable> roomsAvailible = hotelDao.getRoomsAvailibilityByDateAndLocation(hotelLocation, dateFrom, dateTo, numberOfBeds, flexible);
         Map<Hotels, List<HotelRoomAvailable>> roomsByHotels = roomsAvailible.stream().collect(Collectors.groupingBy(x -> x.getHotelRoom().getHotel()));
         List<HotelDto> hotelsList = roomsByHotels.keySet().stream()
@@ -195,20 +230,30 @@
         HotelRoom room = hotelDao.findRoomById(hotelRoomId);
         User user = usersDao.findUserByID(userId);
-        hotelDao.createReservation(user, room, dateFrom, dateTo, numberOfBeds);
+        HotelRoomReservations r = new HotelRoomReservations(user, room, dateFrom, dateTo, numberOfBeds);
         editRoomAvailibleReservation(hotelRoomAvailableId, hotelRoomId, dateFrom, dateTo, numberOfBeds);
+        hotelDao.createReservation(r);
+
     }
 
     @Override
     public void editReservation(long hotelRoomReservedId, User user, HotelRoom hotelRoom, Date dateFrom, Date dateTo, Integer numberOfBeds) {
-        hotelDao.editReservation(hotelRoomReservedId, user, hotelRoom, dateFrom, dateTo, numberOfBeds);
+        HotelRoomReservations hr = findReservationById(hotelRoomReservedId);
+        hr.setUser(user);
+        hr.setHotelRoom(hotelRoom);
+        hr.setDateFrom(dateFrom);
+        hr.setDateTo(dateTo);
+        hr.setNumberOfBeds(numberOfBeds);
+        hotelDao.editReservation(hr);
     }
 
     @Override
     public void deleteReservation(long hotelRoomReservedId) {
-        hotelDao.deleteReservation(hotelRoomReservedId);
-    }
-
-    @Override
-<<<<<<< HEAD
+        HotelRoomReservations r = findReservationById(hotelRoomReservedId);
+        HotelRoomAvailable hra = new HotelRoomAvailable(r.getHotelRoom(), r.getDateFrom(), r.getDateTo(), r.getNumberOfBeds());
+        hotelDao.createRoomAvailible(hra);
+        hotelDao.deleteReservation(r);
+    }
+
+    @Override
     public List<HotelReservationDto> findVaidReseravtionsByHotel(Long hotelId) {
         Hotels hotel = findHotelByID(hotelId);
@@ -230,4 +275,5 @@
         List<HotelRoomReservations> reservations = hotelDao.findReservationByUser(u);
         return reservations.stream().map(x -> new HotelReservationUserDto(
+                x.getHotelRoomReservedId(),
                 x.getUser(),
                 x.getHotelRoom(),
@@ -244,6 +290,4 @@
 
     @Override
-=======
->>>>>>> parent of ac19a0c (authContext impl, admin panel impl, search bar fixes, reservations listings impl)
     public HotelRoomReservations findReservationById(long hotelRoomReservedId) {
         return hotelDao.findReservationById(hotelRoomReservedId);
@@ -276,4 +320,5 @@
         List<HotelRoomReservations> reservations = hotelDao.findPastReservationByUser(u);
         return reservations.stream().map(x -> new HotelReservationUserDto(
+                x.getHotelRoomReservedId(),
                 x.getUser(),
                 x.getHotelRoom(),
@@ -294,3 +339,10 @@
         filesToAdd.stream().map(file -> new HotelRoomImages(hr, file)).forEach(x -> hotelDao.addRoomImage(x));
     }
+
+    @Override
+    public void setReservationReviewed(Long reservationId) {
+        HotelRoomReservations hotelRoomReservations = findReservationById(reservationId);
+        hotelRoomReservations.setReviewed(true);
+        hotelDao.saveReservation(hotelRoomReservations);
+    }
 }
Index: src/main/java/com/tourMate/services/impl/ImageManagerImpl.java
===================================================================
--- src/main/java/com/tourMate/services/impl/ImageManagerImpl.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/services/impl/ImageManagerImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -56,4 +56,8 @@
             hotelManager.addRoomImage(id, filesToAdd);
         }
+        else if(type.equals("menu"))
+        {
+            restaurantManager.addMenuImage(id, filesToAdd);
+        }
 
         return filesToAdd;
Index: src/main/java/com/tourMate/services/impl/MenuManagerImpl.java
===================================================================
--- src/main/java/com/tourMate/services/impl/MenuManagerImpl.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/services/impl/MenuManagerImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -17,10 +17,11 @@
     @Override
     public void createMenu(String name, String ingredients, double price) {
-        menuDao.createMenu(name, ingredients, price);
+        menuDao.createMenu(new Menu(name, ingredients, price));
     }
 
     @Override
     public void deleteMenu(long menuId) {
-        menuDao.deleteMenu(menuId);
+        Menu menu = findMenuById(menuId);
+        menuDao.deleteMenu(menu);
     }
 
@@ -37,5 +38,9 @@
     @Override
     public void editMenu(long menuId, String name, String ingredients, double price) {
-        menuDao.editMenu(menuId, name, ingredients, price);
+        Menu menu = findMenuById(menuId);
+        menu.setName(name);
+        menu.setIngredients(ingredients);
+        menu.setPrice(price);
+        menuDao.editMenu(menu);
     }
 }
Index: src/main/java/com/tourMate/services/impl/RestaurantManagerImpl.java
===================================================================
--- src/main/java/com/tourMate/services/impl/RestaurantManagerImpl.java	(revision 5528b99794e1d3a36baa8eb2f1829125b75f0174)
+++ src/main/java/com/tourMate/services/impl/RestaurantManagerImpl.java	(revision 07f4e8b52fa18ab7781f9660c09d7982d8cd5a0b)
@@ -3,4 +3,5 @@
 import com.tourMate.dao.RestaurantDao;
 import com.tourMate.dto.RestaurantDto;
+import com.tourMate.dto.RestaurantReservationDto;
 import com.tourMate.dto.RestaurantReservationUserDto;
 import com.tourMate.services.RestaurantManager;
@@ -22,29 +23,35 @@
     @Autowired
     UsersManager usersManager;
+
     @Override
     public void createRestaurant(Restaurant restaurant, long userId) {
-        restaurantDao.createRestaurant(restaurant, userId);
-    }
-
-
+        User u = usersManager.findUserByID(userId);
+        Restaurant r = new Restaurant(restaurant.getRestaurantName(), restaurant.getRestaurantLocation(), restaurant.getCousineType(), restaurant.getRestaurantDescription(), restaurant.getRestaurantEdbs(), u);
+        restaurantDao.createRestaurant(r);
+    }
+
+    @Override
+    public void deleteRestaurant(Long restaurantID) {
+        Restaurant r = findRestaurantByID(restaurantID);
+        restaurantDao.deleteRestaurant(r);
+    }
+
+    @Override
+    public void addMenuToRestaurant(long restaurantId, Menu menu) {
+        Restaurant r = findRestaurantByID(restaurantId);
+        menu.setRestaurant(r);
+        restaurantDao.addMenuToRestaurant(menu);
+    }
+
+    @Override
+    public List<Restaurant> getRestaurantsByUser(long userId) {
+        User u = usersManager.findUserByID(userId);
+        return restaurantDao.getRestaurantsByUser(u);
+    }
 
     @Override
     public void deleteRestaurant(long restaurantID) {
-        restaurantDao.deleteRestaurant(restaurantID);
-    }
-
-    @Override
-    public void addMenuToRestaurant(long restaurantId, Menu menu) {
-        restaurantDao.addMenuToRestaurant(restaurantId, menu);
-    }
-
-    @Override
-    public List<Restaurant> getRestaurantsByUser(long userId) {
-        return restaurantDao.getRestaurantsByUser(userId);
-    }
-
-    @Override
-    public void deleteHotel(long restaurantID) {
-        restaurantDao.deleteRestaurant(restaurantID);
+        Restaurant r = findRestaurantByID(restaurantID);
+        restaurantDao.deleteRestaurant(r);
     }
 
@@ -67,5 +74,6 @@
     @Override
     public void removeRestaurantImage(long restaurantImageId) {
-        restaurantDao.removeRestaurantImage(restaurantImageId);
+        RestaurantImages restaurantImage = findRestaurantImageById(restaurantImageId);
+        restaurantDao.removeRestaurantImage(restaurantImage);
     }
 
@@ -81,5 +89,5 @@
 
     @Override
-    public List<RestaurantDto> getTablesByDateAndLocation(String restaurantLocation, Date hourFrom, Date hourTo, int noSeats){
+    public List<RestaurantDto> getTablesByDateAndLocation(String restaurantLocation, Date hourFrom, Date hourTo, int noSeats) {
         List<RestaurantsAvailible> restaurantsAvailibles = restaurantDao.getTablesByDateAndLocation(restaurantLocation, hourFrom, hourTo, noSeats);
         Map<Restaurant, List<RestaurantsAvailible>> tablesByRestaurants = restaurantsAvailibles.stream().collect(Collectors.groupingBy(x -> x.getRestaurantTable().getRestaurant()));
@@ -96,5 +104,6 @@
                         getReviewsForRestaurant(x.getRestaurantID()),
                         getReviewsForRestaurant(x.getRestaurantID()).stream().mapToDouble(Reviews::getNumStar).average().orElse(0),
-                        getRestaurantImages(x.getRestaurantID())
+                        getRestaurantImages(x.getRestaurantID()),
+                        getMenuImagesByRestaurant(x.getRestaurantID())
                 )).toList();
         return restaurantsList;
@@ -103,5 +112,23 @@
     @Override
     public void editRestaurant(long restaurantID, String restaurantName, String restaurantLocation, String cousineType, String restaurantDescription, String restaurantEdbs, User restaurantOwner) {
-        restaurantDao.editRestaurant(restaurantID, restaurantName, restaurantLocation, cousineType, restaurantDescription, restaurantEdbs, restaurantOwner);
+        Restaurant res = findRestaurantByID(restaurantID);
+        res.setRestaurantName(restaurantName);
+        res.setRestaurantLocation(restaurantLocation);
+        res.setRestaurantEdbs(restaurantEdbs);
+        res.setRestaurantDescription(restaurantDescription);
+        res.setRestaurantOwner(restaurantOwner);
+        res.setCousineType(cousineType);
+        restaurantDao.createRestaurant(res);
+    }
+
+    @Override
+    public void editReservation(long restaurantsTableId, RestaurantsTable rt, Date hourFrom, Date hourTo, int noSeats, User user){
+        RestaurantReservations r = findReservationByID(restaurantsTableId);
+        r.setTable(rt);
+        r.setTimeFrom(hourFrom);
+        r.setTimeTo(hourTo);
+        r.setNoSeats(noSeats);
+        r.setUser(user);
+        restaurantDao.saveReservation(r);
     }
 
@@ -119,26 +146,31 @@
     public void createTable(Long restaurantId, int noSeats) {
         Restaurant r = restaurantDao.findRestaurantByID(restaurantId);
-        restaurantDao.createTable(r, noSeats);
+        RestaurantsTable restaurantsTable = new RestaurantsTable(r, noSeats);
+        restaurantDao.saveTable(restaurantsTable);
     }
 
     @Override
     public void editTable(Restaurant restaurant, long tableId, int noSeats) {
-        restaurantDao.editTable(restaurant, tableId, noSeats);
+        RestaurantsTable resTable = findTableById(tableId);
+        resTable.setRestaurant(restaurant);
+        resTable.setNoSeats(noSeats);
+        restaurantDao.saveTable(resTable);
     }
 
     @Override
     public void deleteTable(long tableId) {
-        restaurantDao.deleteTable(tableId);
-    }
-
-    @Override
-    public void createTableAvailable(Long rt, Date hourFrom, Date hourTo) {
+        RestaurantsTable rt = findTableById(tableId);
+        restaurantDao.deleteTable(rt);
+    }
+
+    @Override
+    public void createTableAvailable(Long rt, Date hourFrom, Date hourTo, int numTables) {
         RestaurantsTable rtabl = findTableById(rt);
-        restaurantDao.createTableAvailable(rtabl, hourFrom, hourTo);
-    }
-
-    @Override
-    public List<RestaurantsAvailible> getTablesAvailabilityById(Long id)
-    {
+        RestaurantsAvailible ra = new RestaurantsAvailible(rtabl, hourFrom, hourTo, numTables);
+        restaurantDao.saveTableAvailable(ra);
+    }
+
+    @Override
+    public List<RestaurantsAvailible> getTablesAvailabilityById(Long id) {
         return restaurantDao.getTablesAvailabilityById(id);
     }
@@ -146,20 +178,19 @@
     @Override
     public void editTableAvailable(long tableId, Restaurant restaurant, int noSeats) {
-        restaurantDao.editTableAvailable(tableId, restaurant, noSeats);
+        RestaurantsTable rt = findTableById(tableId);
+        rt.setRestaurant(restaurant);
+        rt.setNoSeats(noSeats);
+        restaurantDao.saveTable(rt);
     }
 
     @Override
     public void deleteTableAvailable(long tableId) {
-        restaurantDao.deleteTableAvailable(tableId);
-    }
-
-    @Override
-    public List<RestaurantsTable> getTablesAvailability() {
-        return null;
-    }
-
-    @Override
-    public void createReservation(Restaurant restaurant, int noSeats) {
-
+        RestaurantsAvailible ra = findAvailableReservationByID(tableId);
+        restaurantDao.deleteTableAvailable(ra);
+    }
+
+    @Override
+    public RestaurantsAvailible findAvailableReservationByID(long tableId){
+        return restaurantDao.findAvailableReservationByID(tableId);
     }
 
@@ -170,29 +201,17 @@
     }
 
-    @Override
-    public void editReservation(long tableId, Restaurant restaurant, int noSeats) {
-        //restaurantDao.editReservation(tableId, restaurant, noSeats);
-    }
 
     @Override
     public void deleteReservation(long tableId) {
-        restaurantDao.deleteReservation(tableId);
+        RestaurantReservations r = findReservationByID(tableId);
+        RestaurantsAvailible ra = new RestaurantsAvailible(r.getTable(), r.getTimeFrom(), r.getTimeTo(), r.getNoSeats());
+        restaurantDao.saveTableAvailable(ra);
+        restaurantDao.deleteReservation(r);
     }
 
     @Override
     public RestaurantReservations findReservationByID(long tableId) {
-        //return restaurantDao.findReservationByID(tableId);
-        return null;
-    }
-
-    @Override
-    public List<RestaurantReservations> findAvailableReservationByID() {
-        return null;
-    }
-
-    @Override
-    public List<RestaurantReservations> findAvailableReservationByID(long reservationId) {
-        return null;
-        // return restaurantDao.findAvailableReservationByID(reservationId);
+        return restaurantDao.findReservationByID(tableId);
+        //return null;
     }
 
@@ -203,6 +222,13 @@
 
     @Override
-    public List<RestaurantReservations> findReservationByRestaurant(Restaurant restaurant) {
-        return restaurantDao.findReservationByRestaurant(restaurant);
+    public List<RestaurantReservationDto> findReservationByRestaurant(Long restaurant) {
+        Restaurant r = findRestaurantByID(restaurant);
+        List<RestaurantReservations> res = restaurantDao.findReservationByRestaurant(r);
+        return res.stream().map(x -> new RestaurantReservationDto(
+                x.getUser(),
+                x.getTable(),
+                x.getTimeFrom(),
+                x.getTimeTo()
+        )).collect(Collectors.toList());
     }
 
@@ -251,9 +277,11 @@
     }
 
-    public void editTableAvailability(RestaurantsAvailible restaurantsAvailible, RestaurantsTable table, Date dateFrom, Date dateTo)
-    {
+    public void editTableAvailability(RestaurantsAvailible restaurantsAvailible, RestaurantsTable table, Date dateFrom, Date dateTo) {
         restaurantsAvailible.setNumTables(restaurantsAvailible.getNumTables() - 1);
-        restaurantDao.createTableAvailable(table, restaurantsAvailible.getHourFrom(), dateFrom, 1);
-        restaurantDao.createTableAvailable(table, dateTo, restaurantsAvailible.getHourTo(), 1);
+        RestaurantsAvailible ra1 = new RestaurantsAvailible(table, restaurantsAvailible.getHourFrom(), dateFrom, 1);
+        RestaurantsAvailible ra2 = new RestaurantsAvailible(table, dateTo, restaurantsAvailible.getHourTo(), 1);
+
+        restaurantDao.saveTableAvailable(ra1);
+        restaurantDao.saveTableAvailable(ra2);
     }
 
@@ -263,4 +291,5 @@
         List<RestaurantReservations> reservations = restaurantDao.findReservationByUser(u);
         return reservations.stream().map(x -> new RestaurantReservationUserDto(
+                x.getReservationId(),
                 x.getUser(),
                 x.getTable(),
@@ -281,4 +310,5 @@
         List<RestaurantReservations> reservations = restaurantDao.findPastReservationsByUser(u);
         return reservations.stream().map(x -> new RestaurantReservationUserDto(
+                x.getReservationId(),
                 x.getUser(),
                 x.getTable(),
@@ -293,3 +323,32 @@
         )).toList();
     }
+
+    @Override
+    public List<MenuImages> getMenuImages(Long id) {
+        return restaurantDao.getMenuImages(id);
+    }
+
+    @Override
+    public void addMenuImage(Long menuId, List<String> url) {
+        Menu r = restaurantDao.findMenuId(menuId);
+        url.stream().map(file -> new MenuImages(r, file)).forEach(x -> restaurantDao.addMenuImage(x));
+    }
+
+    @Override
+    public Menu findMenuById(Long menuId) {
+        return restaurantDao.findMenuId(menuId);
+    }
+
+    @Override
+    public void setReservationReviewed(Long reservationId) {
+        RestaurantReservations restaurantReservations = findReservationByID(reservationId);
+        restaurantReservations.setReviewed(true);
+        restaurantDao.saveReservation(restaurantReservations);
+    }
+
+    @Override
+    public List<MenuImages> getMenuImagesByRestaurant(long restaurantId) {
+        Restaurant r = findRestaurantByID(restaurantId);
+        return restaurantDao.getMenuImagesByRestaurant(r);
+    }
 }
